/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>																											 
#include "NUC1xx.h"

/*----------------------------------------------------------------------------
  Interrupt subroutine
  ----------------------------------------------------------------------------*/
void ADC_IRQHandler(void) // Timer0 interrupt subroutine 
{
	ADC->ADSR.ADF=1;
	   
}
/*----------------------------------------------------------------------------
  MAIN function
  ----------------------------------------------------------------------------*/
int32_t main (void)
{
                           
	/* Step 1. GPIO initial */ 
	SYS->GPBMFP.UART0_RX 	=1;
	SYS->GPBMFP.UART0_TX 	=1;
				
	/* Step 2. Enable and Select UART clock source*/		
	UNLOCKREG();
	SYSCLK->PWRCON.XTL12M_EN = 1;
	LOCKREG();
		
	SYSCLK->APBCLK.UART0_EN = 1;//Enable UART clock
	SYSCLK->CLKSEL1.UART_S = 0;	//Select 12Mhz for UART clock source											           
	SYSCLK->CLKDIV.UART_N = 0;	//UART clock source = 12Mhz;

	/* Step 3. Select Operation mode */
	UART0->FCR.TFR =1;			//Reset Tx FIFO
	UART0->FCR.RFR =1;			//Reset Rx FIFO

	UART0->FCR.RFITL = 0;//Set Rx Trigger Level -1byte FIFO  
	UART0->LCR.PBE	= 0;//Disable parity
	UART0->LCR.WLS	= 3;//8 data bits
	UART0->LCR.NSB	= 0;//Enable 1 Stop bit
		
	/* Step 4. Set BaudRate */
	UART0->BAUD.DIVX_EN = 1;
	UART0->BAUD.DIVX1   = 1;
	UART0->BAUD.DIV = 12000000 / 115200  -2;
	
	do
	{	
		printf("\nUART Sample Demo. (Press 'ESC' to exit)\n");
	}while(GetChar()!=0x1B);

	printf("Exit\n");
}





